/* Copyright (c) 2010 Michael Pippig
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <pnfft.h>
#include <ipnfft.h>

static void default_fft_size(
    const INT *N,
    INT *n, R *x_max);
static int default_m(
    void);



void PNX(local_size_adv)(
    int d, const INT *N, MPI_Comm comm_cart_2d,
    INT *local_N, INT *local_N_start,
    R *lower_border, R *upper_border
    )
{
  int m;
  INT n[3];
  R x_max[3];

  m = default_m();
  default_fft_size(N,
      n, x_max);

  PNX(local_size_guru)(
      d, N, n, x_max, m, comm_cart_2d,
      local_N, local_N_start, lower_border, upper_border);
}


void PNX(init_adv)(
    PNX(plan) *ths, int d, const INT *N,
    INT local_M,
    unsigned nfft_flags, unsigned fftw_flags,
    MPI_Comm comm_cart_2d
    )
{
  int m;
  INT n[3];
  R x_max[3];

  m = default_m();
  default_fft_size(N,
      n, x_max);

  PNX(init_guru)(
      ths, d, N, n, x_max, local_M, m,
      nfft_flags, fftw_flags, comm_cart_2d);
}


static void default_fft_size(
    const INT *N,
    INT *n, R *x_max
    )
{
  for(int t=0; t<3; t++){
    n[t] = 2*N[t];
    x_max[t] = 0.5;
  }
//   n[0] = no[0] = 2*N[0];
}


static int default_m(
    void
    )
{
  return 4;
}
